/*
 *  TKnobControl.h
 *  AUStk
 *
 *  Created by Airy Andr on Sun Oct 20 2002.
 *  Copyright (c) 2002 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef TKnobControl_H_
#define TKnobControl_H_

#include "TViewNoCompositingCompatible.h"

#define kTKnobControlClassID	CFSTR( "com.airy.ctrl.knob" )

class TKnobControl
: public TViewNoCompositingCompatible
{
public:
    static OSStatus Create(
			   HIViewRef*					outControl,
			   const HIRect*				inBounds = NULL,
			   WindowRef					inWindow = NULL,
			   CFStringRef 				classID = kTKnobControlClassID);
    
    static void RegisterClass(CFStringRef str = kTKnobControlClassID);
    static void RegisterClassForBundleID(CFStringRef bid);
    static void SetClassBundle(CFBundleRef sBundle);

    // Accessors

protected:
	// Contstructor/Destructor
	TKnobControl(HIViewRef inControl);
    virtual ~TKnobControl();

    virtual ControlKind		GetKind();

    virtual OSStatus		Initialize( TCarbonEvent& inEvent );
    virtual void		CompatibleDraw(RgnHandle	inLimitRgn, CGContextRef inContext,bool  inCompositing );
    virtual ControlPartCode 	HitTest( const HIPoint&	inWhere );
    virtual OSStatus 		Track( TCarbonEvent& inEvent, ControlPartCode*	outPart );
    virtual OSStatus		TitleChanged();
    virtual OSStatus		GetRegion(ControlPartCode inPart, RgnHandle outRgn );
    virtual OSStatus		ValueChanged();

private:
    CFBundleRef mBundleRef;
    CGImageRef mImage;
    CGImageRef mBackImage;
    float mXOffset, mYOffset; // offset for knob on background
    float mMinAngle, mMaxAngle;
    
    static CFBundleRef      sStaticBundle;
    static OSStatus		Construct(ControlRef inControl, TView**	outView);


};

#endif // TKnobControl