/*
 *  TValuePictControl.h
 *  AUStk
 *
 *  Created by Airy Andr on Sun Oct 20 2002.
 *  Copyright (c) 2002 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef TValuePictControl_H_
#define TValuePictControl_H_

#include "TViewNoCompositingCompatible.h"

#define kTValuePictControlClassID	CFSTR( "com.airy.ctrl.valpng" )

class TValuePictControl
: public TViewNoCompositingCompatible
{
public:
    static OSStatus Create(
			   HIViewRef*					outControl,
			   const HIRect*				inBounds = NULL,
			   WindowRef					inWindow = NULL,
			   CFStringRef 				classID = kTValuePictControlClassID);
    
    static HIObjectClassRef mClassRef;
    static void RegisterClass(CFStringRef str = kTValuePictControlClassID);
    static void RegisterClassForBundleID(CFStringRef bid);
    static void SetClassBundle(CFBundleRef sBundle);

    // Accessors

protected:
	// Contstructor/Destructor
	TValuePictControl(HIViewRef inControl);
    virtual ~TValuePictControl();

    virtual ControlKind		GetKind();

    virtual OSStatus		Initialize( TCarbonEvent& inEvent );
    virtual ControlPartCode 	HitTest( const HIPoint&	inWhere );
    virtual OSStatus 		Track( TCarbonEvent& inEvent, ControlPartCode*	outPart );
    virtual void		CompatibleDraw(RgnHandle	inLimitRgn, CGContextRef inContext,bool  inCompositing );
    virtual OSStatus		TitleChanged();
    virtual OSStatus		ValueChanged();
    virtual OSStatus		GetRegion(ControlPartCode inPart, RgnHandle outRgn );
    virtual UInt32			GetBehaviors();

private:
    CFBundleRef mBundleRef;
    CGImageRef mImage;
    CFMutableDictionaryRef mImageCache;
    
    static CFBundleRef      sStaticBundle;
    static OSStatus		Construct(ControlRef inControl, TView**	outView);


};

#endif // 